Attribute VB_Name = "ModAni"
Option Explicit

' Author:          Stuart Pennington.
' Project:         Animated Cursor Player etc...
' Test Platform:   Windows 98SE With P2-300MHz Processor.


Public NewFileName$
Public NewFileTitle$


Type ANIHEADER
     cbSizeof As Long
     cFrames As Long
     cSteps As Long
     cx As Long
     cy As Long
     cBitCount As Long
     cPlanes As Long
     jifRate As Long
     nFlags As Long
End Type

Type OPENFILENAME
     lStructSize As Long
     hwndOwner As Long
     hInstance As Long
     lpstrFilter As String
     lpstrCustomFilter As String
     nMaxCustFilter As Long
     nFilterIndex As Long
     lpstrFile As String
     nMaxFile As Long
     lpstrFileTitle As String
     nMaxFileTitle As Long
     lpstrInitialDir As String
     lpstrTitle As String
     flags As Long
     nFileOffset As Integer
     nFileExtension As Integer
     lpstrDefExt As String
     lCustData As Long
     lpfnHook As Long
     lpTemplateName As String
End Type

Type RECT
     rLeft As Long
     rTop As Long
     rRight As Long
     rBottom As Long
End Type


' A Few API Function's.
Declare Function BitBlt& Lib "gdi32" (ByVal hDestDC&, ByVal x1&, ByVal y1&, ByVal nWidth&, ByVal nHeight&, ByVal hSrcDC&, ByVal xSrc&, ByVal ySrc&, ByVal dwRop&)
Declare Function DestroyIcon& Lib "user32" (ByVal hIcon&)
Declare Function DrawEdge& Lib "user32" (ByVal ahDc&, lpRect As RECT, ByVal nEdge&, ByVal nFlags&)
Declare Function DrawIconEx& Lib "user32" (ByVal ahDc&, ByVal xLeft&, ByVal yTop&, ByVal hIcon&, ByVal cxWidth&, ByVal cyWidth&, ByVal istepIfAniCur&, ByVal hbrFlickerFreeDraw&, ByVal diFlags&)
Declare Function ExtractIconEx& Lib "shell32.dll" Alias "ExtractIconExA" (ByVal lpszFile$, ByVal nIconIndex&, phiconLarge&, phiconSmall&, ByVal nIcons&)
Declare Function GetOpenFileName& Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME)
Declare Function GetSaveFileName& Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME)
Declare Function SetRect& Lib "user32" (lpRect As RECT, ByVal x1&, ByVal y1&, ByVal x2&, ByVal y2&)


Public Const AF_ICON = 1
Public Const AF_SEQUENCE = 2

' 4 Character Code (FourCC Constants) For Ani's (And Other RIFF Stuff).
' RIFF = Resource Interchange File Format.

Public Const FOURCC_RIFF = 1179011410  ' The File Is In RIFF Format.
Public Const FOURCC_ACON = 1313817409  ' The File Contains An Icon/Cursor Animation.
Public Const FOURCC_LIST = 1414744396  ' The File Contains A RIFF "List".
Public Const FOURCC_INFO = 1330007625  ' The File Contains An Info Section.
Public Const FOURCC_INAM = 1296125513  ' The File Contains The Name Of The Animation.
Public Const FOURCC_IART = 1414676809  ' The File Contains The Name Of The Artist.
Public Const FOURCC_ANIH = 1751740001  ' The File Contains An "ANIHEADER" Structure.
Public Const FOURCC_RATE = 1702125938  ' The File Contains Timing Data (Jiff's).
Public Const FOURCC_SEQ = 544302451    ' The File Contains Sequencing Data.
Public Const FOURCC_FRAM = 1835102822  ' The File Contains "Frame" Data.
Public Const FOURCC_ICON = 1852793705  ' The File Contains Graphics Data (Cursor/Icon)

Public Const Ttl As String = "Ani Player"
Public Function GetFileName(DialogType%) As Boolean

    ' Get A File Name.

    Dim Rv&, Pos%
    Dim OFN As OPENFILENAME

    ' Initialize The Structure.
    With OFN
         If DialogType = 0 Then
           .flags = 4100  ' Decimal
           .lpstrTitle = Ttl & " - Open"
           .lpstrFilter = "Animated Cursor Files (*.ani)" & vbNullChar & "*.ani" & vbNullChar & vbNullChar
         Else
           .flags = 2054  ' Decimal
           .lpstrTitle = Ttl & " - Save As"
           .lpstrFilter = "Bitmap Files (*.bmp)" & vbNullChar & "*.bmp" & vbNullChar & vbNullChar
           .lpstrDefExt = ".bmp"
         End If

        .lStructSize = Len(OFN)
        .hInstance = App.hInstance
        .hwndOwner = FrmAni.hWnd
        .nFilterIndex = 1
        .lpstrFile = String(260, 0)
        .lpstrFileTitle = String(260, 0)
        .nMaxFile = 260
        .nMaxFileTitle = 260
    End With

    ' Display The Dialog.
    If DialogType = 0 Then
       Rv = GetOpenFileName(OFN)
    Else
       Rv = GetSaveFileName(OFN)
    End If
    DoEvents

    If Rv = 1 Then
       Pos = InStr(OFN.lpstrFile, vbNullChar)
       NewFileName = Left(OFN.lpstrFile, Pos - 1)
       Pos = InStr(OFN.lpstrFileTitle, vbNullChar)
       NewFileTitle = StrConv(Left(OFN.lpstrFileTitle, Pos - 1), vbProperCase)
       GetFileName = True
    End If

End Function
